<template>
  <div class="panel-select-buttons btn-group">
    <icon-button
      :active="currentPanel === 'layer-panel'"
      icon="layer-group"
      @click="select('layer-panel')"/>
    <icon-button
      :active="currentPanel === 'locations-panel'"
      icon="map-marker"
      @click="select('locations-panel')"/>
    <template v-if="workspaceCount === 1">
      <icon-button
        icon="clone"
        @click="createWorkspace()"/>
    </template>
    <template v-else>
      <icon-button
        icon="times"
        @click="deleteWorkspace()"/>
      <template v-if="!linked">
        <icon-button
          icon="link"
          @click="linkWorkspaces()"/>
      </template>
      <template v-else>
        <icon-button
          icon="unlink"
          @click="unlinkWorkspaces()"/>
      </template>
    </template>
  </div>
</template>

<script>
import { IconButton } from '@/core/components'
import { SET_WORKSPACE_CURRENT_PANEL, CREATE_WORKSPACE, DELETE_WORKSPACE } from '@/workspace/store/mutations'
import { LINK_WORKSPACES } from '@/store'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'

export default {
  name: 'panelselectbuttons',

  mixins: [
    WorkspaceGetter
  ],

  components: {
    IconButton,
  },

  computed: {
    currentPanel: {
      get() {
        return this.$store.getters.workspaceCurrentPanel(this.workspaceId)
      }
    },

    workspaceCount: {
      get() {
        return this.$store.getters.workspaceCount
      }
    },

    linked: {
      get () {
        return this.$store.getters.linked
      }
    }
  },

  methods: {
    select(panelName) {
      if(this.currentPanel === panelName) {
        this.$store.commit(SET_WORKSPACE_CURRENT_PANEL, {
          workspaceId: this.workspaceId,
          panel: null,
        })
      } else {
        this.$store.commit(SET_WORKSPACE_CURRENT_PANEL, {
          workspaceId: this.workspaceId,
          panel: panelName,
        })
      }
    },

    createWorkspace() {
      this.$store.commit(CREATE_WORKSPACE)
    },

    deleteWorkspace() {
      this.$store.commit(DELETE_WORKSPACE, {
        workspaceId: this.workspaceId
      })
    },

    linkWorkspaces () {
      this.$store.commit(LINK_WORKSPACES, {
        linked: true,
        emitter: this.workspaceId
      })
    },

    unlinkWorkspaces () {
      this.$store.commit(LINK_WORKSPACES, {
        linked: false,
        emitter: this.workspaceId
      })
    }
  },
}
</script>
